unit UFactory;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, Grids, Outline, ExtCtrls, UGlob;

type


  TParameter = Record
                 Value : $0..$7F;
                 Send  : Boolean;
               End;

  TMasterKeyShift = Record
                      Value : $28..$58;
                      Send  : Boolean;
                    End;

  TReverb = Record
              Macro     : $0..$7;
              Character : $0..$7;
              PreLPF    : $0..$7;
              Level     : $0..$7F;
              Time      : $0..$7F;
              Delay     : $0..$7F;
              SendChor  : $0..$7F;
              Send     : Boolean;
            End;

  TChorus = Record
              Macro    : $0..$7;
              PreLPF   : $0..$7;
              Level    : $0..$7F;
              FeedBack : $0..$7F;
              Delay    : $0..$7F;
              Rate     : $0..$7F;
              Depth    : $0..$7F;
              SendRev  : $0..$7F;
              Send     : Boolean;
            End;

  TChannelType = Record
                   ChType : Array[0..15] Of $0..$1;
                   Send   : Boolean;
                 End;

  TAfterTouch = Record
                  AfterTouch : Array[0..15] Of $0..$7F;
                  Send       : Boolean;
                End;

  TVoiceReserve = Record
                    Channel : Array[0..15] Of $0..$18;
                    Send    : Boolean;
                  End;

  TMessage = class
    GSReset : TValue;
    MasterVolume : TParameter;
    MasterKeyShift : TMasterKeyShift;
    MasterPan : TParameter;
    Reverb : TReverb;
    Chorus : TChorus;
    ChannelType : TChannelType;
    AfterTouch : TAfterTouch;
    VoiceReserve : TVoiceReserve;
    function GetResetMode : TValue;
    procedure SetResetMode(Mode : TValue);
    function GetMasterVolume : TValue;
    procedure SetMasterVolume(Value : TValue);
    function GetMasterKeyShift : TValue;
    procedure SetMasterKeyShift(Value : TValue);
    function GetMasterPan : TValue;
    procedure SetMasterPan(Value : TValue);
    procedure SelectAll;
    procedure UnSelectAll;
    procedure RestoreAll;
    function CheckVoiceReserve : Boolean;
  end;

  TfrmFactory = class(TForm)
    btOkay: TButton;
    btCancel: TButton;
    btHelp: TButton;
    PageControl: TPageControl;
    pgEffects: TTabSheet;
    pgMaster: TTabSheet;
    TabSheet1: TTabSheet;
    Label1: TLabel;
    Label2: TLabel;
    Bevel1: TBevel;
    Label15: TLabel;
    Label17: TLabel;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    VReserve1: TTrackBar;
    Label25: TLabel;
    Label26: TLabel;
    Label27: TLabel;
    Label28: TLabel;
    Label29: TLabel;
    Label30: TLabel;
    Label31: TLabel;
    Label32: TLabel;
    Label33: TLabel;
    Label34: TLabel;
    Label35: TLabel;
    Label36: TLabel;
    Label37: TLabel;
    Label38: TLabel;
    Label39: TLabel;
    ChanType1: TRadioGroup;
    ChanType2: TRadioGroup;
    ChanType3: TRadioGroup;
    ChanType4: TRadioGroup;
    ChanType5: TRadioGroup;
    ChanType6: TRadioGroup;
    ChanType7: TRadioGroup;
    ChanType8: TRadioGroup;
    ChanType9: TRadioGroup;
    ChanType0: TRadioGroup;
    ChanType10: TRadioGroup;
    ChanType11: TRadioGroup;
    ChanType12: TRadioGroup;
    ChanType13: TRadioGroup;
    ChanType14: TRadioGroup;
    ChanType15: TRadioGroup;
    GroupBox3: TGroupBox;
    Label40: TLabel;
    Label41: TLabel;
    AfterTouch1: TRadioGroup;
    AfterTouch2: TRadioGroup;
    AfterTouch3: TRadioGroup;
    AfterTouch4: TRadioGroup;
    AfterTouch5: TRadioGroup;
    AfterTouch6: TRadioGroup;
    AfterTouch7: TRadioGroup;
    AfterTouch8: TRadioGroup;
    AfterTouch9: TRadioGroup;
    AfterTouch0: TRadioGroup;
    AfterTouch10: TRadioGroup;
    AfterTouch11: TRadioGroup;
    AfterTouch12: TRadioGroup;
    AfterTouch13: TRadioGroup;
    AfterTouch14: TRadioGroup;
    AfterTouch15: TRadioGroup;
    lbVReserve1: TLabel;
    Bevel2: TBevel;
    VReserve2: TTrackBar;
    lbVReserve2: TLabel;
    Bevel3: TBevel;
    VReserve3: TTrackBar;
    lbVReserve3: TLabel;
    Bevel4: TBevel;
    Bevel5: TBevel;
    Bevel6: TBevel;
    Bevel7: TBevel;
    Bevel8: TBevel;
    Bevel9: TBevel;
    Bevel10: TBevel;
    Bevel11: TBevel;
    Bevel12: TBevel;
    Bevel13: TBevel;
    Bevel14: TBevel;
    Bevel15: TBevel;
    Bevel16: TBevel;
    VReserve4: TTrackBar;
    lbVReserve4: TLabel;
    lbVReserve5: TLabel;
    VReserve5: TTrackBar;
    lbVReserve6: TLabel;
    VReserve6: TTrackBar;
    Label48: TLabel;
    VReserve7: TTrackBar;
    lbVReserve7: TLabel;
    lbVReserve8: TLabel;
    VReserve8: TTrackBar;
    lbVReserve9: TLabel;
    VReserve9: TTrackBar;
    lbVReserve0: TLabel;
    VReserve0: TTrackBar;
    lbVReserve10: TLabel;
    VReserve10: TTrackBar;
    lbVReserve11: TLabel;
    VReserve11: TTrackBar;
    lbVReserve12: TLabel;
    VReserve12: TTrackBar;
    lbVReserve13: TLabel;
    VReserve13: TTrackBar;
    lbVReserve14: TLabel;
    VReserve14: TTrackBar;
    VReserve15: TTrackBar;
    lbVReserve15: TLabel;
    ReverbMacro: TComboBox;
    ChorusMacro: TComboBox;
    revCharacter: TTrackBar;
    revPreLPF: TTrackBar;
    revLevel: TTrackBar;
    revTime: TTrackBar;
    revDelay: TTrackBar;
    revSend: TTrackBar;
    chorPreLPF: TTrackBar;
    chorLevel: TTrackBar;
    chorFeedback: TTrackBar;
    chorRate: TTrackBar;
    chorDepth: TTrackBar;
    chorSend: TTrackBar;
    Label59: TLabel;
    Label60: TLabel;
    MasterVolume: TTrackBar;
    MasterPan: TTrackBar;
    MasterKeyShift: TTrackBar;
    lbrevCharacter: TLabel;
    lbrevPreLPF: TLabel;
    lbrevLevel: TLabel;
    lbrevTime: TLabel;
    lbrevDelay: TLabel;
    lbrevSend: TLabel;
    lbchorPreLPF: TLabel;
    lbchorLevel: TLabel;
    lbchorFeedback: TLabel;
    lbchorRate: TLabel;
    lbchorDepth: TLabel;
    lbchorSend: TLabel;
    lbMasterVolume: TLabel;
    lbMasterPan: TLabel;
    lbMasterKeyShift: TLabel;
    chkMasterVolume: TCheckBox;
    chkMasterPan: TCheckBox;
    chkMasterKeyShift: TCheckBox;
    chkrevCharacter: TCheckBox;
    chkrevMacro: TCheckBox;
    chkrevPreLPF: TCheckBox;
    chkrevLevel: TCheckBox;
    chkrevTime: TCheckBox;
    chkrevDelay: TCheckBox;
    chkrevSend: TCheckBox;
    chkchorMacro: TCheckBox;
    chkchorPreLPF: TCheckBox;
    chkchorLevel: TCheckBox;
    chkchorFeedback: TCheckBox;
    chkchorRate: TCheckBox;
    chkchorDepth: TCheckBox;
    chkchorSend: TCheckBox;
    chkChannelType: TCheckBox;
    chkAfterTouch: TCheckBox;
    chkVoiceReserve: TCheckBox;
    btUnselect: TButton;
    btSelect: TButton;
    btRestore: TButton;
    Image1: TImage;
    Label44: TLabel;
    Label45: TLabel;
    chkEnterGS: TRadioButton;
    chkExitGS: TRadioButton;
    chkNoReset: TRadioButton;
    TooManyVoices: TLabel;
    Triangle: TImage;
    Label3: TLabel;
    procedure FormActivate(Sender: TObject);
    procedure chkEnterGSClick(Sender: TObject);
    procedure chkExitGSClick(Sender: TObject);
    procedure btOkayClick(Sender: TObject);
    Procedure GenerateMessages;
    procedure revCharacterChange(Sender: TObject);
    procedure UpdateLabels;
    procedure MasterVolumeChange(Sender: TObject);
    procedure MasterPanChange(Sender: TObject);
    procedure MasterKeyShiftChange(Sender: TObject);
    procedure revPreLPFChange(Sender: TObject);
    procedure revLevelChange(Sender: TObject);
    procedure revTimeChange(Sender: TObject);
    procedure revDelayChange(Sender: TObject);
    procedure revSendChange(Sender: TObject);
    procedure chorPreLPFChange(Sender: TObject);
    procedure chorLevelChange(Sender: TObject);
    procedure chorFeedbackChange(Sender: TObject);
    procedure chorRateChange(Sender: TObject);
    procedure chorDepthChange(Sender: TObject);
    procedure chorSendChange(Sender: TObject);
    procedure VReserve1Change(Sender: TObject);
    procedure VReserve2Change(Sender: TObject);
    procedure VReserve3Change(Sender: TObject);
    procedure VReserve4Change(Sender: TObject);
    procedure VReserve5Change(Sender: TObject);
    procedure VReserve6Change(Sender: TObject);
    procedure VReserve7Change(Sender: TObject);
    procedure VReserve8Change(Sender: TObject);
    procedure VReserve9Change(Sender: TObject);
    procedure VReserve0Change(Sender: TObject);
    procedure VReserve10Change(Sender: TObject);
    procedure VReserve11Change(Sender: TObject);
    procedure VReserve12Change(Sender: TObject);
    procedure VReserve13Change(Sender: TObject);
    procedure VReserve14Change(Sender: TObject);
    procedure VReserve15Change(Sender: TObject);
    procedure CheckVoices;
    procedure btSelectClick(Sender: TObject);
    procedure btUnselectClick(Sender: TObject);
    procedure btRestoreClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmFactory: TfrmFactory;
  SysExMessage: TMessage;

implementation
  Uses UMain, USysExBody;

{$R *.DFM}

procedure TMessage.SelectAll;
Begin
//
End;

procedure TMessage.UnSelectAll;
Begin
//
End;

procedure TMessage.RestoreAll;
Begin
//
End;

function TMessage.CheckVoiceReserve : Boolean;
Begin
//
  Result := False;
End;

function TMessage.GetResetMode : TValue;
Begin
//
End;

procedure TMessage.SetResetMode(Mode : TValue);
Begin
//
End;

function TMessage.GetMasterVolume : TValue;
Begin
//
End;

procedure TMessage.SetMasterVolume(Value : TValue);
Begin
//
End;

function TMessage.GetMasterKeyShift : TValue;
Begin
//
End;

procedure TMessage.SetMasterKeyShift(Value : TValue);
Begin
//
End;

procedure TMessage.SetMasterPan(Value : TValue);
Begin
//
End;

function TMessage.GetMasterPan : TValue;
Begin
//
End;

procedure TfrmFactory.FormActivate(Sender: TObject);
begin
  If ReverbMacro.ItemIndex = -1 Then ReverbMacro.ItemIndex := 4;
  If ChorusMacro.ItemIndex = -1 Then ChorusMacro.ItemIndex := 2;
  UpdateLabels;
end;

procedure TfrmFactory.chkEnterGSClick(Sender: TObject);
begin
  ChkExitGS.Checked := False;
end;

procedure TfrmFactory.chkExitGSClick(Sender: TObject);
begin
  chkEnterGS.Checked := False;
end;

Procedure TfrmFactory.GenerateMessages;
Var TempStr : String;
Begin
  frmSysExBody.SysBody.Lines.Clear;

  /////////////////////// M A S T E R   S E T T I N G S ////////////////////////

  {Reset}
  If Not chkNoReset.Checked Then { No Reset }
  Begin
    If chkEnterGS.Checked Then TempStr := GSReset
                          Else TempStr := GSExit;
    TempStr := SysExGSMode.SyxMsg + TempStr;
    TempStr := BaseSysExBody + TempStr + CalculateCheckSum(TempStr) + 'F7';
    frmSysExBody.SysBody.Lines.Add(FormatString(TempStr));
  End;
  {MasterVolume}
  If chkMasterVolume.Checked Then
  Begin
    TempStr := SysExMasterVolume.SyxMsg + IntToHex(MasterVolume.Position, 2);
    TempStr := BaseSysExBody + TempStr + CalculateCheckSum(TempStr) + 'F7';
    frmSysExBody.SysBody.Lines.Add(FormatString(TempStr));
  End;
  {MasterPan}
  If chkMasterPan.Checked Then
  Begin
    TempStr := SysExMasterPan.SyxMsg + IntToHex(MasterPan.Position + 63, 2);
    TempStr := BaseSysExBody + TempStr + CalculateCheckSum(TempStr) + 'F7';
    frmSysExBody.SysBody.Lines.Add(FormatString(TempStr));
  End;
  {MasterKeyShift}
  If chkMasterKeyShift.Checked Then
  Begin
    TempStr := SysExMstKeyShift.SyxMsg + IntToHex(MasterKeyShift.Position, 2);
    TempStr := BaseSysExBody + TempStr + CalculateCheckSum(TempStr) + 'F7';
    frmSysExBody.SysBody.Lines.Add(FormatString(TempStr));
  End;

  ///////////////////// R E V E R B   M E S S A G E S ///////////////////////

  {ReverbMacro}
  If chkrevMacro.Checked Then
  Begin
    TempStr := SysExRevMacro.SyxMsg + IntToHex(ReverbMacro.ItemIndex, 2);
    TempStr := BaseSysExBody + TempStr + CalculateCheckSum(TempStr) + 'F7';
    frmSysExBody.SysBody.Lines.Add(FormatString(TempStr));
  End;
  {ReverbCharacter}
  If chkrevCharacter.Checked Then
  Begin
    TempStr := SysExRevCharacter.SyxMsg + IntToHex(revCharacter.Position, 2);
    TempStr := BaseSysExBody + TempStr + CalculateCheckSum(TempStr) + 'F7';
    frmSysExBody.SysBody.Lines.Add(FormatString(TempStr));
  End;
  {ReverbPreLPF}
  If chkrevPreLPF.Checked Then
  Begin
    TempStr := SysExRevPreLPF.SyxMsg + IntToHex(revPreLPF.Position, 2);
    TempStr := BaseSysExBody + TempStr + CalculateCheckSum(TempStr) + 'F7';
    frmSysExBody.SysBody.Lines.Add(FormatString(TempStr));
  End;
  {ReverbLevel}
  If chkrevLevel.Checked Then
  Begin
    TempStr := SysExRevLevel.SyxMsg + IntToHex(revLevel.Position, 2);
    TempStr := BaseSysExBody + TempStr + CalculateCheckSum(TempStr) + 'F7';
    frmSysExBody.SysBody.Lines.Add(FormatString(TempStr));
  End;
  {ReverbTime}
  If chkrevTime.Checked Then
  Begin
    TempStr := SysExRevTime.SyxMsg + IntToHex(revTime.Position, 2);
    TempStr := BaseSysExBody + TempStr + CalculateCheckSum(TempStr) + 'F7';
    frmSysExBody.SysBody.Lines.Add(FormatString(TempStr));
  End;
  {ReverbDelay}
  If chkrevDelay.Checked Then
  Begin
    TempStr := SysExRevDelay.SyxMsg + IntToHex(revDelay.Position, 2);
    TempStr := BaseSysExBody + TempStr + CalculateCheckSum(TempStr) + 'F7';
    frmSysExBody.SysBody.Lines.Add(FormatString(TempStr));
  End;
  {ReverbDelay}
  If chkrevSend.Checked Then
  Begin
    TempStr := SysExRevSend.SyxMsg + IntToHex(revSend.Position, 2);
    TempStr := BaseSysExBody + TempStr + CalculateCheckSum(TempStr) + 'F7';
    frmSysExBody.SysBody.Lines.Add(FormatString(TempStr));
  End;

  /////////////////////// C H O R U S   M E S S A G E S ////////////////////////

  {ChorusMacro}
  If chkchorMacro.Checked Then
  Begin
    TempStr := SysExchorMacro.SyxMsg + IntToHex(ChorusMacro.ItemIndex, 2);
    TempStr := BaseSysExBody + TempStr + CalculateCheckSum(TempStr) + 'F7';
    frmSysExBody.SysBody.Lines.Add(FormatString(TempStr));
  End;
  {ChorusPreLPF}
  If chkchorPreLPF.Checked Then
  Begin
    TempStr := SysExchorPreLPF.SyxMsg + IntToHex(chorPreLPF.Position, 2);
    TempStr := BaseSysExBody + TempStr + CalculateCheckSum(TempStr) + 'F7';
    frmSysExBody.SysBody.Lines.Add(FormatString(TempStr));
  End;
  {ChorusLevel}
  If chkchorLevel.Checked Then
  Begin
    TempStr := SysExchorLevel.SyxMsg + IntToHex(chorLevel.Position, 2);
    TempStr := BaseSysExBody + TempStr + CalculateCheckSum(TempStr) + 'F7';
    frmSysExBody.SysBody.Lines.Add(FormatString(TempStr));
  End;
  {ChorusFeedback}
  If chkchorFeedback.Checked Then
  Begin
    TempStr := SysExchorFeedback.SyxMsg + IntToHex(chorFeedback.Position, 2);
    TempStr := BaseSysExBody + TempStr + CalculateCheckSum(TempStr) + 'F7';
    frmSysExBody.SysBody.Lines.Add(FormatString(TempStr));
  End;
  {ChorusRate}
  If chkchorRate.Checked Then
  Begin
    TempStr := SysExchorRate.SyxMsg + IntToHex(chorRate.Position, 2);
    TempStr := BaseSysExBody + TempStr + CalculateCheckSum(TempStr) + 'F7';
    frmSysExBody.SysBody.Lines.Add(FormatString(TempStr));
  End;
  {ChorusDepth}
  If chkchorDepth.Checked Then
  Begin
    TempStr := SysExchorDepth.SyxMsg + IntToHex(chorDepth.Position, 2);
    TempStr := BaseSysExBody + TempStr + CalculateCheckSum(TempStr) + 'F7';
    frmSysExBody.SysBody.Lines.Add(FormatString(TempStr));
  End;
  {ChorusSend}
  If chkchorSend.Checked Then
  Begin
    TempStr := SysExchorSend.SyxMsg + IntToHex(chorSend.Position, 2);
    TempStr := BaseSysExBody + TempStr + CalculateCheckSum(TempStr) + 'F7';
    frmSysExBody.SysBody.Lines.Add(FormatString(TempStr));
  End;

  /////////////////// T O N E / R H Y T H M   M E S S A G E S //////////////////

  {ChannelType (Drum or Tone)}
  If chkChannelType.Checked Then
  Begin
    {Channel 1}
    TempStr := InsertChannel(SysExUseForRhythm.SyxMsg, 1) + ChannelType[ChanType1.ItemIndex];
    TempStr := BaseSysExBody + TempStr + CalculateCheckSum(TempStr) + 'F7';
    frmSysExBody.SysBody.Lines.Add(FormatString(TempStr));
    {Channel 2}
    TempStr := InsertChannel(SysExUseForRhythm.SyxMsg, 2) + ChannelType[ChanType2.ItemIndex];
    TempStr := BaseSysExBody + TempStr + CalculateCheckSum(TempStr) + 'F7';
    frmSysExBody.SysBody.Lines.Add(FormatString(TempStr));
    {Channel 3}
    TempStr := InsertChannel(SysExUseForRhythm.SyxMsg, 3) + ChannelType[ChanType3.ItemIndex];
    TempStr := BaseSysExBody + TempStr + CalculateCheckSum(TempStr) + 'F7';
    frmSysExBody.SysBody.Lines.Add(FormatString(TempStr));
    {Channel 4}
    TempStr := InsertChannel(SysExUseForRhythm.SyxMsg, 4) + ChannelType[ChanType4.ItemIndex];
    TempStr := BaseSysExBody + TempStr + CalculateCheckSum(TempStr) + 'F7';
    frmSysExBody.SysBody.Lines.Add(FormatString(TempStr));
    {Channel 5}
    TempStr := InsertChannel(SysExUseForRhythm.SyxMsg, 5) + ChannelType[ChanType5.ItemIndex];
    TempStr := BaseSysExBody + TempStr + CalculateCheckSum(TempStr) + 'F7';
    frmSysExBody.SysBody.Lines.Add(FormatString(TempStr));
    {Channel 6}
    TempStr := InsertChannel(SysExUseForRhythm.SyxMsg, 6) + ChannelType[ChanType6.ItemIndex];
    TempStr := BaseSysExBody + TempStr + CalculateCheckSum(TempStr) + 'F7';
    frmSysExBody.SysBody.Lines.Add(FormatString(TempStr));
    {Channel 7}
    TempStr := InsertChannel(SysExUseForRhythm.SyxMsg, 7) + ChannelType[ChanType7.ItemIndex];
    TempStr := BaseSysExBody + TempStr + CalculateCheckSum(TempStr) + 'F7';
    frmSysExBody.SysBody.Lines.Add(FormatString(TempStr));
    {Channel 8}
    TempStr := InsertChannel(SysExUseForRhythm.SyxMsg, 8) + ChannelType[ChanType8.ItemIndex];
    TempStr := BaseSysExBody + TempStr + CalculateCheckSum(TempStr) + 'F7';
    frmSysExBody.SysBody.Lines.Add(FormatString(TempStr));
    {Channel 9}
    TempStr := InsertChannel(SysExUseForRhythm.SyxMsg, 9) + ChannelType[ChanType9.ItemIndex];
    TempStr := BaseSysExBody + TempStr + CalculateCheckSum(TempStr) + 'F7';
    frmSysExBody.SysBody.Lines.Add(FormatString(TempStr));
    {Channel 10}
    TempStr := InsertChannel(SysExUseForRhythm.SyxMsg, 10) + ChannelType[ChanType0.ItemIndex];
    TempStr := BaseSysExBody + TempStr + CalculateCheckSum(TempStr) + 'F7';
    frmSysExBody.SysBody.Lines.Add(FormatString(TempStr));
    {Channel 11}
    TempStr := InsertChannel(SysExUseForRhythm.SyxMsg, 11) + ChannelType[ChanType10.ItemIndex];
    TempStr := BaseSysExBody + TempStr + CalculateCheckSum(TempStr) + 'F7';
    frmSysExBody.SysBody.Lines.Add(FormatString(TempStr));
    {Channel 12}
    TempStr := InsertChannel(SysExUseForRhythm.SyxMsg, 12) + ChannelType[ChanType11.ItemIndex];
    TempStr := BaseSysExBody + TempStr + CalculateCheckSum(TempStr) + 'F7';
    frmSysExBody.SysBody.Lines.Add(FormatString(TempStr));
    {Channel 13}
    TempStr := InsertChannel(SysExUseForRhythm.SyxMsg, 13) + ChannelType[ChanType12.ItemIndex];
    TempStr := BaseSysExBody + TempStr + CalculateCheckSum(TempStr) + 'F7';
    frmSysExBody.SysBody.Lines.Add(FormatString(TempStr));
    {Channel 14}
    TempStr := InsertChannel(SysExUseForRhythm.SyxMsg, 14) + ChannelType[ChanType13.ItemIndex];
    TempStr := BaseSysExBody + TempStr + CalculateCheckSum(TempStr) + 'F7';
    frmSysExBody.SysBody.Lines.Add(FormatString(TempStr));
    {Channel 15}
    TempStr := InsertChannel(SysExUseForRhythm.SyxMsg, 15) + ChannelType[ChanType14.ItemIndex];
    TempStr := BaseSysExBody + TempStr + CalculateCheckSum(TempStr) + 'F7';
    frmSysExBody.SysBody.Lines.Add(FormatString(TempStr));
    {Channel 16}
    TempStr := InsertChannel(SysExUseForRhythm.SyxMsg, 16) + ChannelType[ChanType15.ItemIndex];
    TempStr := BaseSysExBody + TempStr + CalculateCheckSum(TempStr) + 'F7';
    frmSysExBody.SysBody.Lines.Add(FormatString(TempStr));
  End;
  {ChannelAftertouch (On / Off)}
  If chkAfterTouch.Checked Then
  Begin
    {Channel 1}
    TempStr := InsertChannel(SysExCAfTouch.SyxMsg, 1) + ChanAfterTouch[AfterTouch1.ItemIndex];
    TempStr := BaseSysExBody + TempStr + CalculateCheckSum(TempStr) + 'F7';
    frmSysExBody.SysBody.Lines.Add(FormatString(TempStr));
    {Channel 2}
    TempStr := InsertChannel(SysExCAfTouch.SyxMsg, 2) + ChanAfterTouch[AfterTouch2.ItemIndex];
    TempStr := BaseSysExBody + TempStr + CalculateCheckSum(TempStr) + 'F7';
    frmSysExBody.SysBody.Lines.Add(FormatString(TempStr));
    {Channel 3}
    TempStr := InsertChannel(SysExCAfTouch.SyxMsg, 3) + ChanAfterTouch[AfterTouch3.ItemIndex];
    TempStr := BaseSysExBody + TempStr + CalculateCheckSum(TempStr) + 'F7';
    frmSysExBody.SysBody.Lines.Add(FormatString(TempStr));
    {Channel 4}
    TempStr := InsertChannel(SysExCAfTouch.SyxMsg, 4) + ChanAfterTouch[AfterTouch4.ItemIndex];
    TempStr := BaseSysExBody + TempStr + CalculateCheckSum(TempStr) + 'F7';
    frmSysExBody.SysBody.Lines.Add(FormatString(TempStr));
    {Channel 5}
    TempStr := InsertChannel(SysExCAfTouch.SyxMsg, 5) + ChanAfterTouch[AfterTouch5.ItemIndex];
    TempStr := BaseSysExBody + TempStr + CalculateCheckSum(TempStr) + 'F7';
    frmSysExBody.SysBody.Lines.Add(FormatString(TempStr));
    {Channel 6}
    TempStr := InsertChannel(SysExCAfTouch.SyxMsg, 6) + ChanAfterTouch[AfterTouch6.ItemIndex];
    TempStr := BaseSysExBody + TempStr + CalculateCheckSum(TempStr) + 'F7';
    frmSysExBody.SysBody.Lines.Add(FormatString(TempStr));
    {Channel 7}
    TempStr := InsertChannel(SysExCAfTouch.SyxMsg, 7) + ChanAfterTouch[AfterTouch7.ItemIndex];
    TempStr := BaseSysExBody + TempStr + CalculateCheckSum(TempStr) + 'F7';
    frmSysExBody.SysBody.Lines.Add(FormatString(TempStr));
    {Channel 8}
    TempStr := InsertChannel(SysExCAfTouch.SyxMsg, 8) + ChanAfterTouch[AfterTouch8.ItemIndex];
    TempStr := BaseSysExBody + TempStr + CalculateCheckSum(TempStr) + 'F7';
    frmSysExBody.SysBody.Lines.Add(FormatString(TempStr));
    {Channel 9}
    TempStr := InsertChannel(SysExCAfTouch.SyxMsg, 9) + ChanAfterTouch[AfterTouch9.ItemIndex];
    TempStr := BaseSysExBody + TempStr + CalculateCheckSum(TempStr) + 'F7';
    frmSysExBody.SysBody.Lines.Add(FormatString(TempStr));
    {Channel 10}
    TempStr := InsertChannel(SysExCAfTouch.SyxMsg, 10) + ChanAfterTouch[AfterTouch0.ItemIndex];
    TempStr := BaseSysExBody + TempStr + CalculateCheckSum(TempStr) + 'F7';
    frmSysExBody.SysBody.Lines.Add(FormatString(TempStr));
    {Channel 11}
    TempStr := InsertChannel(SysExCAfTouch.SyxMsg, 11) + ChanAfterTouch[AfterTouch10.ItemIndex];
    TempStr := BaseSysExBody + TempStr + CalculateCheckSum(TempStr) + 'F7';
    frmSysExBody.SysBody.Lines.Add(FormatString(TempStr));
    {Channel 12}
    TempStr := InsertChannel(SysExCAfTouch.SyxMsg, 12) + ChanAfterTouch[AfterTouch11.ItemIndex];
    TempStr := BaseSysExBody + TempStr + CalculateCheckSum(TempStr) + 'F7';
    frmSysExBody.SysBody.Lines.Add(FormatString(TempStr));
    {Channel 13}
    TempStr := InsertChannel(SysExCAfTouch.SyxMsg, 13) + ChanAfterTouch[AfterTouch12.ItemIndex];
    TempStr := BaseSysExBody + TempStr + CalculateCheckSum(TempStr) + 'F7';
    frmSysExBody.SysBody.Lines.Add(FormatString(TempStr));
    {Channel 14}
    TempStr := InsertChannel(SysExCAfTouch.SyxMsg, 14) + ChanAfterTouch[AfterTouch13.ItemIndex];
    TempStr := BaseSysExBody + TempStr + CalculateCheckSum(TempStr) + 'F7';
    frmSysExBody.SysBody.Lines.Add(FormatString(TempStr));
    {Channel 15}
    TempStr := InsertChannel(SysExCAfTouch.SyxMsg, 15) + ChanAfterTouch[AfterTouch14.ItemIndex];
    TempStr := BaseSysExBody + TempStr + CalculateCheckSum(TempStr) + 'F7';
    frmSysExBody.SysBody.Lines.Add(FormatString(TempStr));
    {Channel 16}
    TempStr := InsertChannel(SysExCAfTouch.SyxMsg, 16) + ChanAfterTouch[AfterTouch15.ItemIndex];
    TempStr := BaseSysExBody + TempStr + CalculateCheckSum(TempStr) + 'F7';
    frmSysExBody.SysBody.Lines.Add(FormatString(TempStr));
  End;
  { Voice Reservation }
  If chkVoiceReserve.Checked Then
  Begin
    TempStr := SysExVoiceReserve.SyxMsg
               + IntToHex(24 - VReserve0.Position, 2)
               + IntToHex(24 - VReserve1.Position, 2)
               + IntToHex(24 - VReserve2.Position, 2)
               + IntToHex(24 - VReserve3.Position, 2)
               + IntToHex(24 - VReserve4.Position, 2)
               + IntToHex(24 - VReserve5.Position, 2)
               + IntToHex(24 - VReserve6.Position, 2)
               + IntToHex(24 - VReserve7.Position, 2)
               + IntToHex(24 - VReserve8.Position, 2)
               + IntToHex(24 - VReserve9.Position, 2)
               + IntToHex(24 - VReserve10.Position, 2)
               + IntToHex(24 - VReserve11.Position, 2)
               + IntToHex(24 - VReserve12.Position, 2)
               + IntToHex(24 - VReserve13.Position, 2)
               + IntToHex(24 - VReserve14.Position, 2)
               + IntToHex(24 - VReserve15.Position, 2);
    TempStr := BaseSysExBody + TempStr + CalculateCheckSum(TempStr) + 'F7';
    frmSysExBody.SysBody.Lines.Add(FormatString(TempStr));
  End;
End;

procedure TfrmFactory.btOkayClick(Sender: TObject);
begin
  GenerateMessages;
end;

procedure TfrmFactory.UpdateLabels;
Begin
  lbrevCharacter.Caption := IntToStr(revCharacter.Position);
  lbrevPreLPF.Caption := IntToStr(revPreLPF.Position);
  lbrevLevel.Caption := IntToStr(revLevel.Position);
  lbrevTime.Caption := IntToStr(revTime.Position);
  lbrevDelay.Caption := IntToStr(revDelay.Position);
  lbrevSend.Caption := IntToStr(revSend.Position);
  lbchorPreLPF.Caption := IntToStr(chorPreLPF.Position);
  lbchorLevel.Caption := IntToStr(chorLevel.Position);
  lbchorFeedback.Caption := IntToStr(chorFeedback.Position);
  lbchorRate.Caption := IntToStr(chorRate.Position);
  lbchorDepth.Caption := IntToStr(chorDepth.Position);
  lbchorSend.Caption := IntToStr(chorSend.Position);
  lbMasterVolume.Caption := IntToStr(MasterVolume.Position);
  lbMasterPan.Caption := IntToStr(MasterPan.Position);
  lbMasterKeyShift.Caption := IntToStr((64 - MasterKeyShift.Position) * (-1));
  lbVReserve0.Caption := IntToStr(24 - VReserve0.Position);
  lbVReserve1.Caption := IntToStr(24 - VReserve1.Position);
  lbVReserve2.Caption := IntToStr(24 - VReserve2.Position);
  lbVReserve3.Caption := IntToStr(24 - VReserve3.Position);
  lbVReserve4.Caption := IntToStr(24 - VReserve4.Position);
  lbVReserve5.Caption := IntToStr(24 - VReserve5.Position);
  lbVReserve6.Caption := IntToStr(24 - VReserve6.Position);
  lbVReserve7.Caption := IntToStr(24 - VReserve7.Position);
  lbVReserve8.Caption := IntToStr(24 - VReserve8.Position);
  lbVReserve9.Caption := IntToStr(24 - VReserve9.Position);
  lbVReserve10.Caption := IntToStr(24 - VReserve10.Position);
  lbVReserve11.Caption := IntToStr(24 - VReserve11.Position);
  lbVReserve12.Caption := IntToStr(24 - VReserve12.Position);
  lbVReserve13.Caption := IntToStr(24 - VReserve13.Position);
  lbVReserve14.Caption := IntToStr(24 - VReserve14.Position);
  lbVReserve15.Caption := IntToStr(24 - VReserve15.Position);
End;

procedure TfrmFactory.CheckVoices;
Var Sum : Integer;
Begin
  Sum := 384 - (VReserve0.Position + VReserve1.Position + VReserve2.Position +
         VReserve3.Position + VReserve4.Position + VReserve5.Position +
         VReserve6.Position + VReserve7.Position + VReserve8.Position +
         VReserve9.Position + VReserve10.Position + VReserve11.Position +
         VReserve12.Position + VReserve13.Position + VReserve14.Position +
         VReserve15.Position);
  If Sum > 24 Then
  Begin
    btOkay.Enabled := False;
    Triangle.Visible := True;
    TooManyVoices.Caption := 'Too many voices ' + IntToStr(Sum) + '/24)';
    TooManyVoices.Visible := True;
  End
  Else
  Begin
    btOkay.Enabled := True;
    Triangle.Visible := False;
    TooManyVoices.Visible := False;
  End;
End;

procedure TfrmFactory.revCharacterChange(Sender: TObject);
begin
  UpdateLabels;
end;

procedure TfrmFactory.MasterVolumeChange(Sender: TObject);
begin
  UpdateLabels;
end;

procedure TfrmFactory.MasterPanChange(Sender: TObject);
begin
  UpdateLabels;
end;

procedure TfrmFactory.MasterKeyShiftChange(Sender: TObject);
begin
  UpdateLabels;
end;

procedure TfrmFactory.revPreLPFChange(Sender: TObject);
begin
  UpdateLabels;
end;

procedure TfrmFactory.revLevelChange(Sender: TObject);
begin
  UpdateLabels;
end;

procedure TfrmFactory.revTimeChange(Sender: TObject);
begin
  UpdateLabels;
end;

procedure TfrmFactory.revDelayChange(Sender: TObject);
begin
  UpdateLabels;
end;

procedure TfrmFactory.revSendChange(Sender: TObject);
begin
  UpdateLabels;
end;

procedure TfrmFactory.chorPreLPFChange(Sender: TObject);
begin
  UpdateLabels;
end;

procedure TfrmFactory.chorLevelChange(Sender: TObject);
begin
  UpdateLabels;
end;

procedure TfrmFactory.chorFeedbackChange(Sender: TObject);
begin
  UpdateLabels;
end;

procedure TfrmFactory.chorRateChange(Sender: TObject);
begin
  UpdateLabels;
end;

procedure TfrmFactory.chorDepthChange(Sender: TObject);
begin
  UpdateLabels;
end;

procedure TfrmFactory.chorSendChange(Sender: TObject);
begin
  UpdateLabels;
end;

procedure TfrmFactory.VReserve1Change(Sender: TObject);
begin
  UpdateLabels;
  CheckVoices;
end;

procedure TfrmFactory.VReserve2Change(Sender: TObject);
begin
  UpdateLabels;
  CheckVoices;
end;

procedure TfrmFactory.VReserve3Change(Sender: TObject);
begin
  UpdateLabels;
  CheckVoices;
end;

procedure TfrmFactory.VReserve4Change(Sender: TObject);
begin
  UpdateLabels;
  CheckVoices;
end;

procedure TfrmFactory.VReserve5Change(Sender: TObject);
begin
  UpdateLabels;
  CheckVoices;
end;

procedure TfrmFactory.VReserve6Change(Sender: TObject);
begin
  UpdateLabels;
  CheckVoices;
end;

procedure TfrmFactory.VReserve7Change(Sender: TObject);
begin
  UpdateLabels;
  CheckVoices;
end;

procedure TfrmFactory.VReserve8Change(Sender: TObject);
begin
  UpdateLabels;
  CheckVoices;
end;

procedure TfrmFactory.VReserve9Change(Sender: TObject);
begin
  UpdateLabels;
  CheckVoices;
end;

procedure TfrmFactory.VReserve0Change(Sender: TObject);
begin
  UpdateLabels;
  CheckVoices;
end;

procedure TfrmFactory.VReserve10Change(Sender: TObject);
begin
  UpdateLabels;
  CheckVoices;
end;

procedure TfrmFactory.VReserve11Change(Sender: TObject);
begin
  UpdateLabels;
  CheckVoices;
end;

procedure TfrmFactory.VReserve12Change(Sender: TObject);
begin
  UpdateLabels;
  CheckVoices;
end;

procedure TfrmFactory.VReserve13Change(Sender: TObject);
begin
  UpdateLabels;
  CheckVoices;
end;

procedure TfrmFactory.VReserve14Change(Sender: TObject);
begin
  UpdateLabels;
  CheckVoices;
end;

procedure TfrmFactory.VReserve15Change(Sender: TObject);
begin
  UpdateLabels;
  CheckVoices;
end;

procedure TfrmFactory.btSelectClick(Sender: TObject);
begin
  chkEnterGS       .Checked := True;
  chkMasterVolume  .Checked := True;
  chkMasterPan     .Checked := True;
  chkMasterKeyShift.Checked := True;
  chkrevMacro      .Checked := True;
  chkrevCharacter  .Checked := True;
  chkrevPreLPF     .Checked := True;
  chkrevLevel      .Checked := True;
  chkrevTime       .Checked := True;
  chkrevDelay      .Checked := True;
  chkrevSend       .Checked := True;
  chkchorMacro     .Checked := True;
  chkchorPreLPF    .Checked := True;
  chkchorLevel     .Checked := True;
  chkchorFeedback  .Checked := True;
  chkchorRate      .Checked := True;
  chkchorDepth     .Checked := True;
  chkchorSend      .Checked := True;
  chkChannelType   .Checked := True;
  chkAfterTouch    .Checked := True;
  chkVoiceReserve  .Checked := True;
end;

procedure TfrmFactory.btUnselectClick(Sender: TObject);
begin
  chkNoReset       .Checked := True;
  chkMasterVolume  .Checked := False;
  chkMasterPan     .Checked := False;
  chkMasterKeyShift.Checked := False;
  chkrevMacro      .Checked := False;
  chkrevCharacter  .Checked := False;
  chkrevPreLPF     .Checked := False;
  chkrevLevel      .Checked := False;
  chkrevTime       .Checked := False;
  chkrevDelay      .Checked := False;
  chkrevSend       .Checked := False;
  chkchorMacro     .Checked := False;
  chkchorPreLPF    .Checked := False;
  chkchorLevel     .Checked := False;
  chkchorFeedback  .Checked := False;
  chkchorRate      .Checked := False;
  chkchorDepth     .Checked := False;
  chkchorSend      .Checked := False;
  chkChannelType   .Checked := False;
  chkAfterTouch    .Checked := False;
  chkVoiceReserve  .Checked := False;
end;

procedure TfrmFactory.btRestoreClick(Sender: TObject);
begin
  revCharacter.Position   := 4;
  revPreLPF.Position      := 0;
  revLevel.Position       := 64;
  revTime.Position        := 64;
  revDelay.Position       := 0;
  revSend.Position        := 0;
  chorPreLPF.Position     := 0;
  chorLevel.Position      := 64;
  chorFeedback.Position   := 8;
  chorRate.Position       := 80;
  chorDepth.Position      := 19;
  chorSend.Position       := 0;
  MasterVolume.Position   := 127;
  MasterPan.Position      := 0;
  MasterKeyShift.Position := 64;
  VReserve0.Position      := 22;
  VReserve1.Position      := 22;
  VReserve2.Position      := 22;
  VReserve3.Position      := 22;
  VReserve4.Position      := 22;
  VReserve5.Position      := 22;
  VReserve6.Position      := 22;
  VReserve7.Position      := 22;
  VReserve8.Position      := 24;
  VReserve9.Position      := 24;
  VReserve10.Position     := 22;
  VReserve11.Position     := 22;
  VReserve12.Position     := 22;
  VReserve13.Position     := 22;
  VReserve14.Position     := 24;
  VReserve15.Position     := 24;
  ReverbMacro.ItemIndex   := 4;
  ChorusMacro.ItemIndex   := 2;
  ChanType0.ItemIndex := 1;
  ChanType1.ItemIndex := 0;
  ChanType2.ItemIndex := 0;
  ChanType3.ItemIndex := 0;
  ChanType4.ItemIndex := 0;
  ChanType5.ItemIndex := 0;
  ChanType6.ItemIndex := 0;
  ChanType7.ItemIndex := 0;
  ChanType8.ItemIndex := 0;
  ChanType9.ItemIndex := 0;
  ChanType10.ItemIndex := 0;
  ChanType11.ItemIndex := 0;
  ChanType12.ItemIndex := 0;
  ChanType13.ItemIndex := 0;
  ChanType14.ItemIndex := 0;
  ChanType15.ItemIndex := 0;
  AfterTouch0.ItemIndex := 0;
  AfterTouch1.ItemIndex := 0;
  AfterTouch2.ItemIndex := 0;
  AfterTouch3.ItemIndex := 0;
  AfterTouch4.ItemIndex := 0;
  AfterTouch5.ItemIndex := 0;
  AfterTouch6.ItemIndex := 0;
  AfterTouch7.ItemIndex := 0;
  AfterTouch8.ItemIndex := 0;
  AfterTouch9.ItemIndex := 0;
  AfterTouch10.ItemIndex := 0;
  AfterTouch11.ItemIndex := 0;
  AfterTouch12.ItemIndex := 0;
  AfterTouch13.ItemIndex := 0;
  AfterTouch14.ItemIndex := 0;
  AfterTouch15.ItemIndex := 0;  
  UpdateLabels;
end;


end.
