unit USysExBody;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, UGlob;

type
  TfrmSysExBody = class(TForm)
    SysBody: TMemo;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    btCheckSum: TButton;
    procedure btCheckSumClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmSysExBody: TfrmSysExBody;

implementation

{$R *.DFM}

procedure TfrmSysExBody.btCheckSumClick(Sender: TObject);
Var MessageBody : String;
begin
  MessageBody := DeleteSpaces(SysBody.SelText);
  If MessageBody <> '' Then
  Begin
    If (Pos(BaseSysExBody, MessageBody) > 0) And (Pos('F7',MessageBody) > 0) Then
    Begin
      {Delete the BaseSysExBody}
      Delete(MessageBody, 1, Length(BaseSysExBody));
      {Delete the old checksum and the SysEx-End String}
      Delete(MessageBody, Length(MessageBody)-3, 6);
      {Check if there are still BaseSysExBodies}
      If Pos(BaseSysExBody, MessageBody) > 0 Then
      Begin
        MessageDlg('You have selected a packed message!' + #13 + #10 +
                   'Try to select only one message!',mtError, [mbOk], 0);
        Exit;
      End;
      {Calculate the new checksum and place it behind the messagebody}
      MessageBody := MessageBody + CalculateChecksum(MessageBody);
      SysBody.SelText := FormatString(BaseSysExBody + MessageBody + 'F7');
    End
    Else MessageDlg('Wrong SysEx Format!',mtError, [mbOk], 0);
  End
  Else MessageDlg('No message was selected!',mtError, [mbOk], 0);
end;

end.
